#include "forms.h"
#include "racal.h"
#include <stdlib.h>
#include <strings.h>
#include <math.h>

FD_racal *fd_racal;
char cfreq[20];

// rx parameters

double freq;
int atten;
int mode;
float bw;
int alc;
int speed;
int rate=2;
float bfo;
int remote=1;
int place=0;
float atune=0.5;

float bwtable[7];
float bwpack[5];

void update(int mode,float bw,int alc,int speed,int rate);
void freqmod(int,int);

void setfreq(double);
void setmode(int);
void setbw(float);
void setspeed(int);
void setrate(int);
void setbfo(float);
void setlevel(int);
void setrem(int);

void getfreq(double *);
void getmode(int *);
void getbw(float *);
void getalc(int *);
void getspeed(int *);
void getrate(int *);
void getbfo(float *);

/*** callbacks and freeobj handles for form racal ***/

void cbif(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  int level;
  level=150*(1.0-fl_get_dial_value(fd_racal->iff));
  setif(level);
  update(mode,bw,alc,speed,rate);
}

void cbaf(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cbrate(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  rate+=1;
  if(rate>3) rate=1;
  update(mode,bw,alc,speed,rate);
}

void cbone(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,1);
}

void cbtwo(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,2);
}

void cbthree(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,3);
}

void cblock(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cbfour(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,4);
}

void cbfive(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,5);
}

void cbsix(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,6);
}

void cbbfo(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(mode==4){
    mode=3;
    sprintf(cfreq,"%f       %4.2f",freq,bfo);
    setmode(mode);
    fl_set_input(fd_racal->freq,cfreq);
  }
  else if(mode==3){
    mode=4;
    sprintf(cfreq,"%f",freq);
    setmode(mode);
    fl_set_input(fd_racal->freq,cfreq);
  }
  //printf("%i %f %i %i \n",mode,bw,alc,speed);
  update(mode,bw,alc,speed,rate);
}

void cbseven(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,7);
}

void cbeight(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,8);
}

void cbnine(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,9);
}

void cbcenter(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  bfo=0.0;
  if(mode==3){
    sprintf(cfreq,"%f       %4.2f",freq,bfo);
    fl_set_input(fd_racal->freq,cfreq);
    setbfo(bfo);
  }
}

void cbenter(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place=0;
}

void cbzero(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  place+=1;
  freqmod(place,0);
}

void cbremote(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  remote=1-remote;
  setrem(remote);
  update(mode,bw,alc,speed,rate);
}

void cbam(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  mode=1;
  setmode(mode);
  update(mode,bw,alc,speed,rate);
  sprintf(cfreq,"%f",freq);
  fl_set_input(fd_racal->freq,cfreq);
}

void cbcw(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  mode=3;
  setmode(mode);
  update(mode,bw,alc,speed,rate);
  //sprintf(cfreq,"%f",freq);
  sprintf(cfreq,"%10.7f       %4.2f",freq,bfo);
  fl_set_input(fd_racal->freq,cfreq);
}

void cblsb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  mode=6;
  setmode(mode);
  update(mode,bw,alc,speed,rate);
  sprintf(cfreq,"%f",freq);
  fl_set_input(fd_racal->freq,cfreq);
}

void cbisb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cbfm(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  mode=2;
  setmode(mode);
  update(mode,bw,alc,speed,rate);
  sprintf(cfreq,"%f",freq);
  fl_set_input(fd_racal->freq,cfreq);
}

void cbbw1(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(mode==1||mode==3||mode==4){
    bw=bwpack[0];
    setbw(bw);
    update(mode,bw,alc,speed,rate);
  }
}

void cbbw2(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(mode==1||mode==3||mode==4){
    bw=bwpack[1];
    setbw(bw);
    update(mode,bw,alc,speed,rate);
  }
}

void cbrf(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cbbw3(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(mode==1||mode==3||mode==4){
    bw=bwpack[2];
    setbw(bw);
    update(mode,bw,alc,speed,rate);
  }
}

void cbbw4(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(mode==1||mode==3||mode==4){
    bw=bwpack[3];
    setbw(bw);
    update(mode,bw,alc,speed,rate);
  }
}

void cbbw5(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(mode==1||mode==3||mode==4){
    bw=bwpack[4];
    setbw(bw);
    update(mode,bw,alc,speed,rate);
  }
}

void cbman(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(speed>3) 
    speed-=4;
  else
    speed+=4;
  setspeed(speed);
  update(mode,bw,alc,speed,rate);
}

void cbshort(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(speed>3)
    speed=5;
  else
    speed=1;
  setspeed(speed);
  update(mode,bw,alc,speed,rate);
}

void cbmed(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(speed>3)
    speed=6;
  else
    speed=2;
  setspeed(speed);
  update(mode,bw,alc,speed,rate);
}

void cblong(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(speed>3)
    speed=7;
  else
    speed=3;
  setspeed(speed);
  update(mode,bw,alc,speed,rate);
}

void cbpower(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  rclose();
  exit(1);
}

void cbusb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  mode=7;
  setmode(mode);
  update(mode,bw,alc,speed,rate);
  sprintf(cfreq,"%f",freq);
  fl_set_input(fd_racal->freq,cfreq);
}

void cbtune(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  atune=fl_get_dial_value(fd_racal->tune);
  //printf("%f \n",atune);
}

void cbfreq(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  strcpy(cfreq,fl_get_input(fd_racal->freq));
  freq=atof(cfreq);
  setfreq(freq);
  update(mode,bw,alc,speed,rate);
}

void cbtimer(FL_OBJECT *ob, long data)
{
  float scale;
  /* fill-in code for callback */

  //printf("timer \n");
  fl_set_timer(fd_racal->timer,1.0);
  update(mode,bw,alc,speed,rate);

  if(fabsf(atune-0.5)>0.075)
    scale=2.0;
  else
    scale=1.0;

  // change frequency?
  if(atune>0.525){
    if(mode==3){
      bfo+=0.01;
      setbfo(bfo);
      sprintf(cfreq,"%f       %4.2f",freq,bfo);
      fl_set_input(fd_racal->freq,cfreq);
    }
    else{
      if(rate==1)
	freq+=0.01*scale;
      else if(rate==2)
	freq+=0.001*scale;
      else
	freq+=0.0001*scale;
      setfreq(freq);
      update(mode,bw,alc,speed,rate);
      sprintf(cfreq,"%f",freq);
      fl_set_input(fd_racal->freq,cfreq);
    }
  }
  else if(atune<0.475){
    if(mode==3){
      bfo-=0.01;
      setbfo(bfo);
      sprintf(cfreq,"%f       %4.2f",freq,bfo);
      fl_set_input(fd_racal->freq,cfreq);
    }
    else{
      if(rate==1)
	freq-=0.01*scale;
      else if(rate==2)
	freq-=0.001*scale;
      else
	freq-=0.0001*scale;
      setfreq(freq);
      update(mode,bw,alc,speed,rate);
      sprintf(cfreq,"%f",freq);
      fl_set_input(fd_racal->freq,cfreq);
    }
  }
}

void cbup(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(mode==3){
    bfo+=0.01;
    setbfo(bfo);
    sprintf(cfreq,"%f       %4.2f",freq,bfo);
    fl_set_input(fd_racal->freq,cfreq);
  }
  else{
    if(rate==1)
      freq+=0.01;
    else if(rate==2)
      freq+=0.001;
    else
      freq+=0.0001;
    setfreq(freq);
    update(mode,bw,alc,speed,rate);
    sprintf(cfreq,"%f",freq);
    fl_set_input(fd_racal->freq,cfreq);
  }
}

void cbdown(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  if(mode==3){
    bfo-=0.01;
    setbfo(bfo);
    sprintf(cfreq,"%f       %4.2f",freq,bfo);
    fl_set_input(fd_racal->freq,cfreq);
  }
  else{
    if(rate==1)
      freq-=0.01;
    else if(rate==2)
      freq-=0.001;
    else
      freq-=0.0001;
    setfreq(freq);
    update(mode,bw,alc,speed,rate);
    sprintf(cfreq,"%f",freq);
    fl_set_input(fd_racal->freq,cfreq);
  }
}


void update(int mode,float bw,int alc,int speed,int rate){
// uodate display window
  char display[120];
  char *man[7]={"   ","   ","   ","MAN","MAN","MAN","MAN"};
  char *cmode[7]={"AM","FM","CW","CW","FM","LSB","USB"};
  char *cspeed[7]={"SHT","MED","LNG","   ","SHT","MED","LNG"};
  char *crate[3]={"FAST","MED","SLW"};
  int i;
 
  getalc(&alc);
  for(i=0;i<(alc)/10;i++)
    sprintf(display+i,">");
  for(i=alc/10;i<12;i++)
    sprintf(display+i,"_");
  //printf("%i %i %i \n",speed,mode,rate);
  /*
  sprintf(display+12,"%3.1fkHz\n\n%s         %s         %s\n%s\n                          REMOTE",bw,cspeed[speed-1],cmode[mode-1],crate[rate-1],man[speed-1]);
  */

  sprintf(display+12,"%3.1fkHz\n\n",bw);
  sprintf(display+strlen(display),"%s         %s         %s\n",cspeed[speed-1],cmode[mode-1],crate[rate-1]);
  sprintf(display+strlen(display),"%s\n",man[speed-1]);
  if(remote==1) 
    sprintf(display+strlen(display),"                          REMOTE");

  fl_set_input(fd_racal->display,display);
}

void freqmod(int place, int no){
  // change one digit of frequency
  char tmp[2];
  int place2;
  if(place>=3)
    place2=place+1;
  else
    place2=place;
  sprintf(cfreq,"%10.7f",freq);
  sprintf(tmp,"%1i",no);
  if(place2==1 && no==0) strncpy(tmp," ",1);
  strncpy(cfreq+place2-1,tmp,1);
  freq=atof(cfreq);
  setfreq(freq);
  update(mode,bw,alc,speed,rate);
  fl_set_input(fd_racal->freq,cfreq);  
}

int main(int argc, char *argv[])
{
   fl_initialize(&argc, argv, 0, 0, 0);
   fd_racal = create_form_racal();
   int i,j,k;

   /* fill-in form initialization code */

   // initialize receiver
   ropen();

   // get bandwidth table
   getband(bwtable);
   for(i=j=0;i<7;i++)
     if(bwtable[i]>0.0){
       bwpack[j]=bwtable[i];
       j++;
     }

   // get receiver status
   // getstat(&freq,&mode,&bw,&alc,&speed,&rate); depreciated

   getfreq(&freq);
   getmode(&mode);
   getbw(&bw);
   getalc(&alc);
   getspeed(&speed);
   getbfo(&bfo);

   // set up main windows
   if(mode==3)
     sprintf(cfreq,"%10.7f       %4.2f",freq,bfo);
   else
     sprintf(cfreq,"%10.7f",freq);
   fl_set_button(fd_racal->power,1);
   fl_set_input(fd_racal->freq,cfreq);
   update(mode,bw,alc,speed,rate);

   // user timer to update rx status once per second
   fl_set_timer(fd_racal->timer,1.0);  

   /* set default if attenuation */
   setif(1);

   /* show the first form */
   fl_show_form(fd_racal->racal,FL_PLACE_CENTERFREE,FL_FULLBORDER,"racal");
   fl_do_forms();
   return 0;
}
